/**
 * Ext GWT 3.0.0-beta4 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.theme.base.client.button;

import com.google.gwt.core.client.GWT;
import com.google.gwt.resources.client.ClientBundle;
import com.google.gwt.resources.client.CssResource;
import com.google.gwt.safehtml.shared.SafeHtml;
import com.google.gwt.safehtml.shared.SafeHtmlBuilder;
import com.sencha.gxt.core.client.XTemplates;
import com.sencha.gxt.core.client.dom.XElement;
import com.sencha.gxt.widget.core.client.button.IconButton.IconButtonAppearance;

public  class IconButtonBaseAppearance implements IconButtonAppearance {

  public interface ToolButtonBaseResources extends ClientBundle {
    
    @Source("IconButton.css")
    IconButtonBaseStyle style();
  }
  
  public interface IconButtonBaseStyle extends CssResource {
    String button();
  }
  

  public interface Template extends XTemplates {
    @XTemplate(source = "IconButton.html")
    SafeHtml render(IconButtonBaseStyle style);
  }

  private Template template;
  private IconButtonBaseStyle style;
  
  public IconButtonBaseAppearance() {
    this(GWT.<ToolButtonBaseResources>create(ToolButtonBaseResources.class));
  }
  
  public IconButtonBaseAppearance(ToolButtonBaseResources resources) {
    this.style = resources.style();
    this.style.ensureInjected();
    
    this.template = GWT.create(Template.class);
  }

  @Override
  public void render(SafeHtmlBuilder sb) {
    sb.append(template.render(style));
  }

  @Override
  public XElement getIconElem(XElement parent) {
    return parent;
  }

}
