/**
 * Ext GWT 3.0.0-beta4 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.theme.base.client.panel;

import com.google.gwt.core.client.GWT;
import com.google.gwt.safecss.shared.SafeStylesBuilder;
import com.google.gwt.safehtml.shared.SafeHtml;
import com.google.gwt.safehtml.shared.SafeHtmlBuilder;
import com.sencha.gxt.core.client.Style.Side;
import com.sencha.gxt.core.client.dom.XElement;
import com.sencha.gxt.core.client.resources.ThemeStyles;
import com.sencha.gxt.theme.base.client.frame.Frame;
import com.sencha.gxt.theme.base.client.frame.NestedDivFrame;
import com.sencha.gxt.theme.base.client.frame.NestedDivFrame.NestedDivFrameResources;
import com.sencha.gxt.widget.core.client.FramedPanel.FramedPanelAppearance;

public abstract class FramedPanelBaseAppearance extends ContentPanelBaseAppearance implements FramedPanelAppearance {

  public interface FramedPanelDivFrameResources extends NestedDivFrameResources {

  }

  public interface Template extends ContentPanelTemplate {
    @XTemplate(source = "FramedPanel.html")
    SafeHtml render(ContentPanelStyle style);
  }

  protected Frame frame;


  public FramedPanelBaseAppearance(ContentPanelDefaultResources resources) {
    this(resources, GWT.<Template> create(Template.class));
  }

  public FramedPanelBaseAppearance(ContentPanelDefaultResources resources, Template template) {
    super(resources, template);

    frame = createFrame();
  }

  @Override
  public XElement getBodyWrap(XElement parent) {
    NestedDivFrame df = (NestedDivFrame) frame;
    return parent.selectNode("." + df.getResources().style().bodyWrap());
  }

  @Override
  public XElement getContentElem(XElement parent) {
    return parent.selectNode("." + style.body());
  }

  @Override
  public int getFrameHeight(XElement parent) {
    NestedDivFrame df = (NestedDivFrame) frame;
    int h = df.getResources().bottomBorder().getHeight();
    h += df.getContentElem(parent).getFrameSize().getHeight();
    return h;
  }

  @Override
  public int getFrameWidth(XElement parent) {
    NestedDivFrame df = (NestedDivFrame) frame;
    int w = df.getResources().leftBorder().getWidth();
    w += df.getResources().rightBorder().getWidth();

    XElement content = getContentElem(parent);
    w += content.getFrameWidth(Side.LEFT, Side.RIGHT);

    return w;
  }

  @Override
  public XElement getHeaderElem(XElement parent) {
    NestedDivFrame df = (NestedDivFrame) frame;
    return parent.selectNode("." + df.getResources().style().top());
  }

  @Override
  public void onBodyBorder(XElement parent, boolean border) {
    getContentElem(parent).setClassName(ThemeStyles.getStyle().border(), border);
  }

  @Override
  public void onHideHeader(XElement parent, boolean hide) {
    parent.addClassName("noheader");
  }

  @Override
  public void render(SafeHtmlBuilder sb) {
    frame.render(sb, template.render(style), new SafeStylesBuilder().toSafeStyles());
  }

  protected abstract Frame createFrame();
}
