/**
 * Ext GWT 3.0.0-beta4 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.widget.core.client.grid;

import com.google.gwt.i18n.client.NumberFormat;
import com.google.gwt.safehtml.shared.SafeHtml;
import com.sencha.gxt.core.client.ValueProvider;

public class SummaryColumnConfig<M, N> extends ColumnConfig<M, N> {

  protected SummaryType<?, ?, ?> summaryType;
  protected SummaryRenderer<M> summaryRenderer;
  protected NumberFormat summaryFormat;

  public SummaryColumnConfig(ValueProvider<M, N> valueProvider) {
    super(valueProvider);
  }

  public SummaryColumnConfig(ValueProvider<M, N> valueProvider, int width) {
    super(valueProvider, width);
  }

  public SummaryColumnConfig(ValueProvider<M, N> valueProvider, int width, SafeHtml name) {
    super(valueProvider, width, name);
  }

  public SummaryColumnConfig(ValueProvider<M, N> valueProvider, int width, String name) {
    super(valueProvider, width, name);
  }

  public NumberFormat getSummaryFormat() {
    return summaryFormat;
  }

  public SummaryRenderer<M> getSummaryRenderer() {
    return summaryRenderer;
  }

  public SummaryType<?, ?, ?> getSummaryType() {
    return summaryType;
  }

  public void setSummaryFormat(NumberFormat summaryFormat) {
    this.summaryFormat = summaryFormat;
  }

  public void setSummaryRenderer(SummaryRenderer<M> summaryRenderer) {
    this.summaryRenderer = summaryRenderer;
  }

  public void setSummaryType(SummaryType<?, ?, ?> summaryType) {
    this.summaryType = summaryType;
  }

}
